import pygame
import random
import enemy
import item
import math
from player import loadImage

fly = []
die = []

def setupAnimations():
	for i in range(1,12):
		path = "data//images//bomber//fly//fly" + str(i) + ".png"
		fly.append(loadImage(path))
	for i in range(1,10):
		path = "data//images//bomber//die//die" + str(i) + ".png"
		die.append(loadImage(path))



class Bomber(enemy.Enemy):	
	def __init__(self,screen,pos):
		self.screen = screen
		
		self.scoreValue	= 10
		self.health = 5
		self.pos = pos
		self.rect = pygame.Rect(0,0,40,30)
		self.drawrect = fly[0].get_rect()
		
		self.currentAnim = 0
		self.animFreq = 1
		self.anim = []
		
		self.lastAttack = -1 #Stores attack that has already damaged the enemy ( so no getting damaged by the same attack)
		self.big = False
		self.mode = "FLY"
		# It may seem stupid but is for period when not alive but is not dead
		self.alive = True
		self.dead = False		
		self.scoreValue	= 100
		self.counter = 0
		self.frame = 0
		self.fly()
		self.tempY = self.pos[1]

	def update(self):
		i = None
		self.frame += 1		
		self.counter += 1		
		if self.counter % self.animFreq == 0:
			self.currentAnim = (self.currentAnim + 1) % len(self.anim)
				

		#print self.counter, self.counter % self.animFreq, self.currentAnim, self.mode
		if self.health <= 0:
			self.die()
		
		if (self.mode == "EXPLODE"):			
			if self.counter > 25:
				self.dead = True
				if random.random() > 0.55:
					i = item.Coffee(self.screen,self.pos)
		
		elif (self.mode == "FLY"):
			self.pos = (self.pos[0]-2,self.tempY + math.sin(self.frame*0.3)*7)				
			if self.frame % 30 == 0:				
				i = item.Bomb(self.screen,(self.pos[0],self.rect.bottom+1))
		elif self.mode == "BURN":
			self.pos = (self.pos[0]+int(random.random()*3)-1,self.pos[1]+int(random.random()*3)-1)
			
		self.rect.center = self.pos		
		return i
			
		
	def fly(self):
		self.mode = "FLY"
		self.playAnim(fly,1)
		self.counter = 0		
		
	def die(self):
		if self.alive:
			self.alive = False
			self.mode = "EXPLODE"
			self.playAnim(die,3)
			self.counter = 0				
		
	def collidePlayer(self,player):
		if self.cp(player):
			player.hurt()

	def unburn(self):
		self.fly()
		self.frame = 0
		self.tempY = self.pos[1]
		
	def burn(self):
		self.mode = "BURN"
		self.playAnim(fly,100)
		self.counter = 0
	
	def knockback(self):
		self.pos = (self.pos[0]+10,self.pos[1])
	def __repr__(self):
		return "{BOMBER->(%r,%r)}" % (str(self.pos[0]),str(self.pos[1]))
		
