import pygame
import random
#import suicide



class Enemy(object):
	def __init__(self,screen,pos):
		self.screen = screen
		self.pos = pos
		self.rect = pygame.Rect(0,0,20,30)
		self.rect.center = self.pos
		self.drawrect = self.rect.copy()
		# Animation stuff
		self.currentAnim = 0
		self.animFreq = 1
		self.anim = []
		self.health = 1
		self.lastAttack = -1 #Stores attack that has already damaged the enemy ( so no getting damaged by the same attack)
		self.big = False
		self.mode = "NORMAL"
		# It may seem stupid but is for period when not alive but is dead
		self.alive = True
		self.dead = False
		self.scoreValue	= 10
		self.deadframe = 0		
	def update(self):
		if self.health < 0 and self.alive:
			self.alive = False
			self.deadframe = 0	
			self.rect.width = 2
			self.rect.height = 2
		if not self.alive:
			self.deadframe += 1
			#print self.deadframe
			if self.deadframe > 30:
				self.dead = True
		self.pos = self.rect.center
	def draw(self,background):
		im = self.anim[self.currentAnim]
		self.drawrect.center = (self.pos[0] - background.xpos, self.pos[1])
		self.screen.blit(im,self.drawrect)
	def collidePlayer(self,player):		
		if self.cp(player):
			player.hurt()
	def cp(self,player):		
		if self.mode == "BURN":
			if player.state.type != "ATTACK" or (not self.rect.colliderect(player.rect)):
				self.unburn()
			
		if not self.alive:
			return False
		if not self.big and player.big:
			if self.rect.colliderect(player.rect):
				self.health = 0	
				player.score += self.scoreValue*player.multiplier
				player.multiply()
			return False
			
		if self.rect.colliderect(player.rect):
			if player.state.type == "ATTACK":
				if self.lastAttack != player.state.atknum:
					self.health -= player.state.getCollisionDamage()
					if player.state.knockback:
						self.knockback()
					if player.state.burn:
						self.burn()
					self.lastAttack =  player.state.atknum				
					player.state = player.state.getCollisionState(self)
					if self.health <= 0:	
						player.score += self.scoreValue*player.multiplier	
						player.multiply()
			else:
				return True
				
		return False	
	def playAnim(self,anim,freq):
		self.currentAnim = 0
		self.animFreq = freq
		self.anim = anim
	def knockback(self):
		pass
	def unburn(self):
		pass
	def burn(self):
		pass
	def getItem(self):
		pass
