import pygame
import text

class HUD(object):
	def __init__(self,screen,player):
		self.player = player
		self.screen = screen
		self.texts = []
		self.texts.append(text.Text(self.screen,"POWER",(60,44),40))
		self.texts.append(text.Text(self.screen,"HEALTH",(574,44),40))
		self.texts.append(text.Text(self.screen,"SCORE",(320,64),40))
		self.score = (text.CounterText(self.screen,"000000000",(320,24),40))
		self.texts2 = []
		self.powerbar = Bar(screen,(15,10),189,16,270,True,(250,250,0))
		self.healthbar = Bar(screen,(436,10),189,16,27,False,(200,22,20))
		self.frame = 0
	def update(self):
		self.frame += 1
		for txt in self.texts:
			txt.update()
		for txt in self.texts2:
			txt.update()
		self.score.update("%.6dx%.2d" % (self.player.score, self.player.multiplier))
		self.powerbar.colour = (160,160,160)
		if self.player.power == 270:
			if self.frame % 2 == 0:
				self.powerbar.colour = (250,250,0)		
		self.powerbar.update(self.player.power)
		self.healthbar.update(self.player.health)
		
		if self.player.transforming and not self.player.big:
			if self.player.tf == 10:
				self.texts2.append(text.FlashyText(self.screen,"NINE TIMES THE SIZE",(320,120),80))
			if self.player.tf == 40:
				self.texts2.append(text.FlashyText(self.screen,"NINE TIMES THE POWER",(320,210),80))
			if self.player.tf == 70:
				self.texts2.append(text.FlashyText(self.screen,"NINE TIMES THE SALARY",(320,300),80))
		else:
			self.texts2 = []
		
	def draw(self):
		for txt in self.texts:
			txt.draw()
		for txt in self.texts2:
			txt.draw()
		self.score.draw()
		self.powerbar.draw()
		self.healthbar.draw()
		
class Bar(object):
	def __init__(self,screen,pos,length,width,maximum,right,colour):
		self.screen = screen
		self.colour = colour
		self.pos = pos
		self.right = right
		self.width = width
		self.length = length
		self.maximum = maximum
		self.current = maximum
		self.rect = pygame.Rect(pos[0],pos[1],self.length,self.width)
	def update(self,value):
		self.current = value
		length = self.current*(1.0/self.maximum)*self.length		
		self.rect.width = length
		if self.right:
			self.rect.left = self.pos[0]
		else:
			self.rect.right = self.pos[0] + self.length			
	def draw(self):
		pygame.draw.rect(self.screen,self.colour,self.rect,0)