import pygame
import player
import background
import title
import hud
import item
import random
import enemies
from pygame.locals import *



class Level(object):
	def __init__(self,screen):				
		self.player = player.Player(screen)
		self.background = background.Background(screen)	
		self.screen = screen
		item.initialiseSprites()
		enemies.setupAnimations()
		self.items = []
		self.nextSpawnPos = 120
		self.powerLevel = 2
		self.enemies = []
		self.hud = hud.HUD(screen,self.player)
	def getInput(self):
		for event in pygame.event.get():
			if event.type == KEYDOWN:
				if event.key == K_ESCAPE:
					pygame.mixer.Channel(1).set_volume(0.1)					
					return title.Title(self.screen)
				if event.key == K_LEFT:
					self.player.move(-1)
				if event.key == K_RIGHT:
					self.player.move(1)
				if event.key == K_UP:
					self.player.jump()
				if event.key == K_DOWN:
					self.player.crouch()
				if event.key == K_SPACE:
					self.player.saction()
			if event.type == KEYUP:					
				if event.key == K_LEFT:
					self.player.stop(-1)
				if event.key == K_RIGHT:
					self.player.stop(1)
				if event.key == K_DOWN:
					self.player.uncrouch()
				if event.key == K_SPACE:
					self.player.deaction()
		return self
	def spawnEnemies(self):
		# Remove dead enemies and offscreen enemies
		self.enemies = [e for e in self.enemies if (not e.dead and e.drawrect.right > 0)]
		# While we are at it remove items too
		self.items = [e for e in self.items if (e.drawrect.right > 0 and e.alive)]
		if self.background.xpos > self.nextSpawnPos:
			self.nextSpawnPos += 640
			self.powerLevel += (1+self.powerLevel/10)
			cp = self.background.xpos + 640
			pl = int(self.powerLevel)
			while(pl > 0):
				print pl
				if pl == 1:
					pl -= 1
					self.enemies.append(enemies.suicide.SuicideBomber(self.screen, (cp-120,-random.random()*30)))
					cp += 7 + int(random.random()*5)
				elif pl == 2:
					r = int(random.random()*2)
					if r == 0:
						pl -= 1
						self.enemies.append(enemies.suicide.SuicideBomber(self.screen, (cp-120,-random.random()*30)))
						cp += 7 + int(random.random()*5)				
					else:
						pl -= 2
						self.enemies.append(enemies.bomber.Bomber(self.screen, (cp,120+random.random()*100)))
						cp += 25 + int(random.random()*5)				
				else:
					gotEnemy = False
					if pl >= 6:
						if random.random() > 0.85:
							pl -= 6
							self.enemies.append(enemies.platform.Platform(self.screen, (cp,-random.random()*30)))
							cp += 35 + int(random.random()*5)	
							gotEnemy = True
					if pl >= 10:
						if random.random() > 0.9:
							pl -= 10
							self.enemies.append(enemies.crusher.Crusher(self.screen, (cp,-random.random()*30)))
							cp += 50 + int(random.random()*5)
							gotEnemy = True						
					if not gotEnemy:
						r = int(random.random()*3)
						if r == 0:
							pl -= 1
							self.enemies.append(enemies.suicide.SuicideBomber(self.screen, (cp-120,-random.random()*30)))
							cp += 10 + int(random.random()*5)
						elif r == 1:
							pl -= 2
							self.enemies.append(enemies.bomber.Bomber(self.screen, (cp,120+random.random()*100)))
							cp += 25 + int(random.random()*5)	 					
						else:
							pl -= 3
							self.enemies.append(enemies.walker.Walker(self.screen, (cp,120+random.random()*100)))
							cp += 20 + int(random.random()*5)
				
			print self.powerLevel, self.enemies			
					#self.enemies.append(enemies.suicide.SuicideBomber(self.screen, (px,py)))
	
			#self.enemies.append(enemies.walker.Walker(self.screen, (px,py)))
		#print len(self.items)
		
	def update(self):				
		if self.player.transforming:			
			self.player.update(self)
			self.hud.update()
			return self.getInput()		
		self.spawnEnemies()			
		self.background.update()
		for i in self.items:
			i.update()
		for e in self.enemies:
			i = e.update()
			if i != None:
				self.items.append(i)
			
		self.player.update(self)
		self.hud.update()
		if self.player.health <= 0:
			return title.EndGame(self.screen,self.player.score)
		return self.getInput()
		
	def draw(self):
		self.background.draw(self.player)		

		self.player.draw(self.background)
		for e in self.enemies:
			e.draw(self.background)
		for i in self.items:
			i.draw(self.background)
		self.hud.draw()	