import pygame
import random
import enemy
import item
from player import loadImage

idle = []
die = []

def setupAnimations():
	for i in range(1,5):
		path = "data//images//suicide//idle//idle" + str(i) + ".png"
		idle.append(loadImage(path))
	for i in range(1,8):
		path = "data//images//suicide//die//die" + str(i) + ".png"
		die.append(loadImage(path))


class SuicideBomber(enemy.Enemy):	
	def __init__(self,screen,pos):
		self.screen = screen
		self.pos = pos
		self.scoreValue	= 5
		self.health = 1
		self.rect = pygame.Rect(0,0,10,15)
		self.rect.center = self.pos
		self.drawrect = idle[0].get_rect()
		self.currentAnim = 0
		self.lastAttack = -1 #Stores attack that has already damaged the enemy ( so no getting damaged by the same attack)
		self.big = False
		self.mode = "FALL"
		# It may seem stupid but is for period when not alive but is dead
		self.alive = True
		self.dead = False		
		self.veloc = 0
		self.scoreValue	= 50
		self.counter = 0
		self.beginDeath = True
		
	def draw(self,background):
		if self.alive:
			im = idle[self.currentAnim]
		else:
			im = die[self.currentAnim]
		self.drawrect.center = (self.pos[0] - background.xpos, self.pos[1])
		self.screen.blit(im,self.drawrect)
	def update(self):
		i = None
		if self.mode == "FALL":
			self.veloc += 2
		
		self.counter += 1
		
		if (self.mode == "WAIT"):			
			if self.counter > 5:
				self.explode()
		if self.health <= 0:
			self.alive = False
		if not self.alive:			
			if self.beginDeath:
				self.beginDeath = False
				self.counter = 1
				self.currentAnim = 0
				self.mode = "DEAD"			
			if self.counter % 3 == 0:
				self.currentAnim += 1
			self.veloc = 0			
			if self.counter > 16:
				self.dead = True
				if random.random() > 0.8:
					i = item.Coffee(self.screen,self.pos)
		else:			
			if self.counter % 6 == 0:
				self.currentAnim = (self.currentAnim + 1) % 4
			

			
		self.rect.bottom = self.rect.bottom + self.veloc/4.0
		
		if self.alive and self.mode == "RUN":
			self.rect.centerx -= 6
		if self.rect.bottom > 300:
			self.rect.bottom = 300
			self.veloc = 0
			if self.mode == "FALL":
				self.mode = "RUN"
		self.pos = self.rect.center
		return i
	def wait(self):
		self.mode = "WAIT"
		self.counter = 0	
				
	def explode(self):
		self.alive = False
		self.mode = "EXPLODE"
		self.beginDeath = False
		self.currentAnim = 0
		self.counter = 0		
		self.rect = pygame.Rect(0,0,25,25)		
		self.rect.center = self.pos
		
	def collidePlayer(self,player):		
		print self.mode
		if not self.alive and self.mode == "EXPLODE":
			self.alive = True
			if self.cp(player):
				player.hurt()
				self.mode = "DEAD"			
			self.alive = False
			return
		if not self.alive:
			return
		if self.cp(player):
			self.explode()
		if self.mode == "RUN":
			d = (player.pos[0]- self.pos[0])**2+(player.pos[1]- self.pos[1])**2
			if d < 400:
				self.wait()
	def __repr__(self):
		return "{SUICIDE BOMBER>(%r,%r)}" % (str(self.pos[0]),str(self.pos[1]))