import pygame
import random

class FlashyText(object):
	def __init__(self,screen,text,pos,size):
		self.screen = screen		
		self.text = text
		self.font = pygame.font.Font("data//font.ttf",size)
		# Initialize position to center of text
		self.pos = (pos[0]-self.font.size(text)[0]/2,pos[1]-self.font.size(text)[1]/2)	
		self.drawpos = self.pos
		self.image = self.font.render(text,False,(255,255,255))
		self.frame = 0
	def update(self):
		# Randomize the texts colour or position		
		if (self.frame % 2) == 0:
			colour = pygame.color.Color(255,0,255,0)
			colour.hsla = (int(random.random()*360),colour.hsla[1],colour.hsla[2],colour.hsla[3])				
			self.image = self.font.render(self.text,False,colour)
		else:
			self.drawpos = (int(self.pos[0]+random.random()*6-3),int(self.pos[1]+random.random()*6-3))
		self.frame += 1
		
	def draw(self):
		self.screen.blit(self.image, self.drawpos)
		
class Text(object):
	def __init__(self,screen,text,pos,size,colour = (255,255,255)):
		self.screen = screen		
		self.font = pygame.font.Font("data//font.ttf",size)
		# Initialize position to center of text
		self.drawpos = (pos[0]-self.font.size(text)[0]/2,pos[1]-self.font.size(text)[1]/2)				
		self.image = self.font.render(text,False,colour)		
	def update(self):
		pass		
	def draw(self):
		self.screen.blit(self.image, self.drawpos)

class CounterText(Text):
	def __init__(self,screen,text,pos,size,colour = (255,255,255)):
		Text.__init__(self,screen,text,pos,size,colour)
		self.ipos = pos
	def update(self,text,colour = (255,255,255)):		
		self.image = self.font.render(text,False,colour)		
		self.pos = (self.ipos[0]-self.font.size(text)[0]/2,self.ipos[1]-self.font.size(text)[1]/2)	
