import pygame
import random
import enemy
import item
from player import loadImage

walk = []
comeout = []
fire = []
die = []

def setupAnimations():
	for i in range(0,6):
		path = "data//images//walker//walk//walk" + str(i) + ".png"
		walk.append(loadImage(path))
	for i in range(1,8):
		path = "data//images//walker//die//die" + str(i) + ".png"
		die.append(loadImage(path))
	for i in range(1,6):
		path = "data//images//walker//fire//fire" + str(i) + ".png"
		fire.append(loadImage(path))
	for i in range(0,3):
		path = "data//images//walker//openclose//opeclose" + str(i) + ".png"
		comeout.append(loadImage(path))


class Walker(enemy.Enemy):	
	def __init__(self,screen,pos):
		self.screen = screen
		
		self.scoreValue	= 5
		self.health = 15
		self.rect = walk[0].get_rect()
		self.rect.centerx = pos[0]
		self.rect.bottom = 300
		self.pos = self.rect.center
		self.rect = pygame.Rect(0,0,25,20)
		self.drawrect = walk[0].get_rect()
		
		self.currentAnim = 0
		self.animFreq = 1
		self.anim = []
		
		self.attackVeloc = (-1,0)
		
		self.lastAttack = -1 #Stores attack that has already damaged the enemy ( so no getting damaged by the same attack)
		self.big = False
		self.mode = "WALK"
		# It may seem stupid but is for period when not alive but is not dead
		self.alive = True
		self.dead = False		
		self.scoreValue	= 200
		self.counter = 0
		self.c2 = 0
		self.walk()

	def update(self):
		i = None
		self.counter += 1		
		if self.mode == "RETRACT":
			if self.counter % self.animFreq == 0:
				self.currentAnim = (self.currentAnim - 1) % len(self.anim)
		else:
			if self.counter % self.animFreq == 0:
				self.currentAnim = (self.currentAnim + 1) % len(self.anim)
				

		#print self.counter, self.counter % self.animFreq, self.currentAnim, self.mode
		if self.health <= 0:
			self.die()
		
		if (self.mode == "EXPLODE"):			
			if self.counter > 19:
				self.dead = True
				if random.random() > 0.3:
					i = item.Coffee(self.screen,self.pos)
		
		elif (self.mode == "WALK"):
			self.pos = (self.pos[0]-1,self.pos[1])
			if self.counter > 90 and self.attackVeloc[0] < 0 and self.drawrect.left < 640:
				self.extend()
		elif self.mode == "EXTEND":
			if self.counter > 16:
				self.fire()			
		elif self.mode == "RETRACT":
			if self.counter > 16:
				self.walk()			
		elif self.mode == "FIRE":
			if self.counter % 10 == 4 and self.attackVeloc[0] < 0:
				i = item.Laser(self.screen,self.pos,self.attackVeloc)
			if self.counter > 29:
				self.retract()					
		elif self.mode == "BURN":
			self.pos = (self.pos[0],self.pos[1]+int(random.random()*3)-1)
			
		self.rect.centerx = self.pos[0]
		self.rect.bottom = 300
		return i	
			
		
	def walk(self):
		self.mode = "WALK"
		self.playAnim(walk,3)
		self.counter = 0		
	def retract(self):
		self.mode = "RETRACT"
		self.playAnim(comeout,6)
		self.counter = 0
		self.currentAnim = 2
	def extend(self):
		self.mode = "EXTEND"
		self.playAnim(comeout,6)
		self.counter = 0	
	def fire(self):
		self.playAnim(fire,2)
		self.mode = "FIRE"
		self.counter = 0		
		# Firing code here
		
	def die(self):
		if self.alive:
			self.alive = False
			self.mode = "EXPLODE"
			self.playAnim(die,3)
			self.counter = 0				
		
	def collidePlayer(self,player):
		if self.cp(player):
			player.hurt()
		xdif = (player.pos[0] - self.pos[0])
		ydif = (player.pos[1] - self.pos[1])
		d = (xdif**2 + ydif**2)**0.5
		if d == 0:
			d = 0.01
		self.attackVeloc = ((12.0/d)*xdif,(12.0/d)*ydif)
	def unburn(self):
		self.walk()
		self.drawrect.bottom = 300
		self.pos = (self.pos[0],self.drawrect.centery)
		self.counter = self.c2
	def burn(self):
		self.mode = "BURN"
		self.playAnim(walk,100)
		self.c2 = self.counter
		self.counter = 0
	
	def knockback(self):
		self.pos = (self.pos[0]+10,self.pos[1])
	def __repr__(self):
		return "{WALKER->(%r,%r)}" % (str(self.pos[0]),str(self.pos[1]))		
